Package: dlstats
Title: Download Stats of R Packages
Version: 0.1.7
Authors@R: c(person(given = "Guangchuang", family = "Yu",
	   	     email = "guangchuangyu@gmail.com",
		    role  = c("aut", "cre"))
	    )
Maintainer: Guangchuang Yu <guangchuangyu@gmail.com>
Description: Monthly download stats of 'CRAN' and 'Bioconductor' packages.
	     Download stats of 'CRAN' packages is from the 'RStudio' 'CRAN mirror', see <https://cranlogs.r-pkg.org:443>.
	     'Bioconductor' package download stats is at <https://bioconductor.org/packages/stats/>.
Depends: R (>= 3.3.0)
Imports: ggplot2, jsonlite, magrittr, RColorBrewer, scales, utils
Suggests: knitr, tidyr, DT, rmarkdown, prettydoc
License: Artistic-2.0
VignetteBuilder: knitr
ByteCompile: true
Encoding: UTF-8
URL: https://github.com/GuangchuangYu/dlstats
BugReports: https://github.com/GuangchuangYu/dlstats/issues
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-05-24 01:50:14 UTC; HUAWEI
Author: Guangchuang Yu [aut, cre]
Repository: CRAN
Date/Publication: 2023-05-24 04:10:02 UTC
Built: R 4.6.0; ; 2026-04-27 22:56:29 UTC; unix

Package: dlstats
Title: Download Stats of R Packages
Version: 0.1.7
Authors@R: c(person(given = "Guangchuang", family = "Yu",
	   	     email = "guangchuangyu@gmail.com",
		    role  = c("aut", "cre"))
	    )
Maintainer: Guangchuang Yu <guangchuangyu@gmail.com>
Description: Monthly download stats of 'CRAN' and 'Bioconductor' packages.
	     Download stats of 'CRAN' packages is from the 'RStudio' 'CRAN mirror', see <https://cranlogs.r-pkg.org:443>.
	     'Bioconductor' package download stats is at <https://bioconductor.org/packages/stats/>.
Depends: R (>= 3.3.0)
Imports: ggplot2, jsonlite, magrittr, RColorBrewer, scales, utils
Suggests: knitr, tidyr, DT, rmarkdown, prettydoc
License: Artistic-2.0
VignetteBuilder: knitr
ByteCompile: true
Encoding: UTF-8
URL: https://github.com/GuangchuangYu/dlstats
BugReports: https://github.com/GuangchuangYu/dlstats/issues
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-05-24 01:50:14 UTC; HUAWEI
Author: Guangchuang Yu [aut, cre]
Repository: CRAN
Date/Publication: 2023-05-24 04:10:02 UTC
Built: R 4.2.0; ; 2023-07-11 01:07:32 UTC; unix

library("shiny")
library("dlstats")
library("ggplot2")

shinyServer(function(input, output, session) {
    cran_pkg_stats <- eventReactive(input$cran_go, {
        pkgs <- gsub("\\s*", "", unlist(strsplit(input$cran_pkg_input, split=',')))
        cran_stats(pkgs)
    })    

    output$cran_trendplot <- renderPlot({
        ggplot(cran_pkg_stats(), aes(end, downloads, color=package)) + geom_line() + xlab(NULL) + ylab(NULL)
    })
  
    output$tbl <- DT::renderDataTable(cran_pkg_stats(), options = list(lengthChange = FALSE))
})

shinyUI(fluidPage(
    titlePanel("dlstats: Download stats of R packages"),
    
    sidebarLayout(
        sidebarPanel(
            textInput("bioc_pkg_input", label = h3("BioC packages"), value = "ChIPseeker, clusterProfiler, DOSE, ggtree, GOSemSim, ReactomePA"),
            actionButton("bioc_go", "Go!")
        ),

        mainPanel(
            tabsetPanel(
                tabPanel("Trend",
                         plotOutput("bioc_trendplot")
                         ),
                tabPanel("Data",
                         DT::dataTableOutput('tbl')
                         )
                
            )
        )
    )
))

## ----style, echo=FALSE, results="asis", message=FALSE-------------------------
knitr::opts_chunk$set(tidy = FALSE,
		   message = FALSE)

## ----echo=FALSE, results="hide", message=FALSE--------------------------------
library("tidyr")
library("ggplot2")
library("dlstats")

## ----fig.width=10-------------------------------------------------------------
library("ggplot2")
library("dlstats")

x <- cran_stats(c("emojifont", "ggimage", "hexSticker", "rvcheck"))

if (!is.null(x)) {
   print(head(x))
   ggplot(x, aes(end, downloads, group=package, color=package)) +
       geom_line() + 
       geom_point() +
       scale_y_log10()
}

## ----fig.width=10-------------------------------------------------------------
pkgs <- c("ChIPseeker", "clusterProfiler", "DOSE", "ggtree", "GOSemSim", "ReactomePA")
y <- bioc_stats(pkgs)

if (!is.null(y)) {
   head(y)
   ggplot(y, aes(end, Nb_of_downloads, group=package, color=package)) +
       geom_line() + geom_point(aes(shape=package))

   library("tidyr")
   yy <- gather(y, type, Nb, Nb_of_distinct_IPs:Nb_of_downloads)

   ggplot(yy, aes(end, Nb, shape=package, color=package)) +geom_point() + geom_line() +
       ylab(NULL) + xlab(NULL) + facet_grid(type~., scales="free_y") +
       ggtitle("Number of downloads per Month") +
       scale_x_date(date_breaks="1 year", date_labels = "%Y")
}

library("shiny")
library("dlstats")
library("ggplot2")
library("DT")

shinyServer(function(input, output, session) {
    bioc_pkg_stats <- eventReactive(input$bioc_go, {
        pkgs <- gsub("\\s*", "", unlist(strsplit(input$bioc_pkg_input, split=',')))
        bioc_stats(pkgs)
    })
  
    output$bioc_trendplot <- renderPlot({
        ggplot(bioc_pkg_stats(), aes(end, Nb_of_downloads, color=package)) + geom_line() + xlab(NULL) + ylab(NULL)
    })

    output$tbl <- DT::renderDataTable(bioc_pkg_stats(), options = list(lengthChange = FALSE))
})

shinyUI(fluidPage(
    titlePanel("dlstats: Download stats of R packages"),
    
    sidebarLayout(
        sidebarPanel(
            textInput("cran_pkg_input", label = h3("CRAN packages"), value = "dlstats, emojifont, rvcheck"),
            actionButton("cran_go", "Go!")
        ),

        mainPanel(
            tabsetPanel(
                tabPanel("Trend",
                         plotOutput("cran_trendplot")
                         ),
                tabPanel("Data",
                         DT::dataTableOutput('tbl')
                         )
                
            )
        )
    )
))

---
title: "dlstats: Download stats of R packages"
author: "\\

	Guangchuang Yu (<guangchuangyu@gmail.com>)\\

        School of Basic Medical Sciences, Southern Medical University"
date: "`r Sys.Date()`"
output:
  prettydoc::html_pretty:
    toc: true
    theme: cayman
    highlight: github
  pdf_document:
    toc: true
vignette: >
  %\VignetteIndexEntry{dlstats introduction}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
  %\VignetteDepends{tidyr}
  %\VignetteDepends{ggplot2}
---

```{r style, echo=FALSE, results="asis", message=FALSE}
knitr::opts_chunk$set(tidy = FALSE,
		   message = FALSE)
```


```{r echo=FALSE, results="hide", message=FALSE}
library("tidyr")
library("ggplot2")
library("dlstats")
```

# Introduction

This `R` package queries download stats of `R` packages.

+ For [CRAN](https://cran.r-project.org/) packages, it queries from RStudio download logs.

+ For [Bioconductor](https://bioconductor.org/) packages, it queries from [Bioconductor download stats](https://bioconductor.org/packages/stats/).


# Download stats of CRAN packages

```{r fig.width=10}
library("ggplot2")
library("dlstats")

x <- cran_stats(c("emojifont", "ggimage", "hexSticker", "rvcheck"))

if (!is.null(x)) {
   print(head(x))
   ggplot(x, aes(end, downloads, group=package, color=package)) +
       geom_line() + 
       geom_point() +
       scale_y_log10()
}
```


# Download stats of Bioconductor packages

```{r fig.width=10}
pkgs <- c("ChIPseeker", "clusterProfiler", "DOSE", "ggtree", "GOSemSim", "ReactomePA")
y <- bioc_stats(pkgs)

if (!is.null(y)) {
   head(y)
   ggplot(y, aes(end, Nb_of_downloads, group=package, color=package)) +
       geom_line() + geom_point(aes(shape=package))

   library("tidyr")
   yy <- gather(y, type, Nb, Nb_of_distinct_IPs:Nb_of_downloads)

   ggplot(yy, aes(end, Nb, shape=package, color=package)) +geom_point() + geom_line() +
       ylab(NULL) + xlab(NULL) + facet_grid(type~., scales="free_y") +
       ggtitle("Number of downloads per Month") +
       scale_x_date(date_breaks="1 year", date_labels = "%Y")
}
```


# Shiny apps

We also provide shiny app for visualizing download stats of R packages.

User can use `cranApp()` or `biocApp()` for `CRAN` packages and `Bioconductor` packages respectively.

```r
biocApp()
```

![](figures/plot.png)

![](figures/data.png)
